import { Document, Text, Block, Inline } from '@contentful/rich-text-types--demo';
declare type NonTextNode = Block | Inline;
declare type Node = Text | NonTextNode;
export declare const defaultInline: (type: string, node: NonTextNode) => string;
export interface Next {
    (nodes: Node[]): string;
}
export interface NodeRenderer {
    (node: NonTextNode, next: Next): string;
}
export interface RenderNode {
    [k: string]: NodeRenderer;
}
export interface MarkRenderer {
    (text: string): string;
}
export interface RenderMark {
    [k: string]: MarkRenderer;
}
export interface Options {
    renderNode?: RenderNode;
    renderMark?: RenderMark;
}
export declare function documentToHtmlString(doc: Document, options?: Partial<Options>): string;
export {};
